import 'package:leoo_junpro/leooflagjunpro/leooappjunpro/leooappconfigjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoodaojunpro/LeooMainDaoJunPro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoodaojunpro/leoodaoresultjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooentityjunpro/leooauditentity.dart';
import 'package:leoo_junpro/leooflagjunpro/leooentityjunpro/leooroomentity.dart';
import 'package:leoo_junpro/leooflagjunpro/leoonetjunpro/leooapphostjunpro.dart';

class LeooRoomDaoJunPro {
  static Future<LeooDataResultJunPro> leooCreateRoomJunPro(String? name,
      String? type, String? timeLength, String? imgUrl, int? userId,
      [int multiRoom = 0]) async {
    Map<String, dynamic> other = {
      'name': name,
      'type': type,
      'timeLength': timeLength,
      'imgUrl': imgUrl,
      'createdUserId': userId,
      'multiRoom': multiRoom,
    };
    var res = await LeooMainDaoJunPro.leooFromBaseJsonJunPro(
        other, LeooAppHostJunPro.leooRoomsJunPro());
    if (res.result) {
      var entity = LeooRoomEntity.fromJson(res.data);
      return LeooDataResultJunPro(entity, true);
    }
    return res;
  }

  static Future<LeooDataResultJunPro> leooRoomsJunPro(int page, String type,
      [int? userId, int? size]) async {
    Map<String, dynamic> other = {
      'page': page,
      'createdUserId': userId,
      'size': size ?? LeooAppConfigJunPro.leooListSizeJunPro,
      'type': type,
    };
    var res = await LeooMainDaoJunPro.leooFromBaseJsonJunPro(
        other, LeooAppHostJunPro.leooRoomsJunPro(),
        option: 'get');
    if (res.result) {
      var data = (res.data['data'] as List)
          .map((v) => LeooRoomEntity.fromJson(v))
          .toList();
      return LeooDataResultJunPro(data, true);
    }
    return res;
  }

  static Future<LeooDataResultJunPro> leooDeleteRoomJunPro(int? id) async {
    var res = await LeooMainDaoJunPro.leooFromBaseJsonJunPro(
        null, LeooAppHostJunPro.leooRoomsJunPro() + '/$id',
        option: 'delete');
    if (res.result) {
      return LeooDataResultJunPro(res.data, true);
    }
    return res;
  }

  static Future<LeooDataResultJunPro> leooLikeRoomJunPro(
      int? roomId, int type) async {
    Map<String, dynamic> other = {
      'roomId': roomId,
      'type': type,
    };
    var res = await LeooMainDaoJunPro.leooFromBaseJsonJunPro(
        other, LeooAppHostJunPro.leooLikeRoomJunPro());
    if (res.result) {
      return LeooDataResultJunPro(res.data, true);
    }
    return res;
  }

  static Future<LeooDataResultJunPro> LeooAddOrEditAuditTreeDataJunPro(
      LeooAuditEntity entity) async {
    Map<String, dynamic> other = entity.toJson();
    var res = await LeooMainDaoJunPro.leooFromBaseJsonJunPro(
        other, LeooAppHostJunPro.leooAddOrEditAuditTreeDataJunPro(),
        room: true);
    if (res.result) {
      var entity = LeooAuditEntity.fromJson(res.data);
      return LeooDataResultJunPro(entity, true);
    }
    return res;
  }

  static Future<LeooDataResultJunPro> LeooAddOrEditAuditUserExtJunPro(
      LeooAuditEntity entity) async {
    Map<String, dynamic> other = entity.toJson();
    var res = await LeooMainDaoJunPro.leooFromBaseJsonJunPro(
        other, LeooAppHostJunPro.leooAddOrEditAuditUserExtJunPro(),
        room: true);
    if (res.result) {
      var entity = LeooAuditEntity.fromJson(res.data);
      return LeooDataResultJunPro(entity, true);
    }
    return res;
  }

  static Future<LeooDataResultJunPro> LeooDeleteAuditTreeDataJunPro(
      int? id) async {
    var res = await LeooMainDaoJunPro.leooFromBaseJsonJunPro(
        null, LeooAppHostJunPro.leooDeleteAuditTreeDataJunPro() + '/$id',
        option: 'delete');
    if (res.result) {
      return LeooDataResultJunPro(res.data, true);
    }
    return res;
  }

  static Future<LeooDataResultJunPro> LeooFindPageAuditTreeDataJunPro(
      int page, LeooAuditEntity entity,
      [int? size]) async {
    Map<String, dynamic> other = {
      'page': page,
      'size': size ?? LeooAppConfigJunPro.leooListSizeJunPro,
    };
    other.addAll(entity.toJson());
    var res = await LeooMainDaoJunPro.leooFromBaseJsonJunPro(
        other, LeooAppHostJunPro.leooFindPageAuditTreeDataJunPro(),
        room: true);
    if (res.result) {
      var data = (res.data['data'] as List)
          .map((v) => LeooAuditEntity.fromJson(v))
          .toList();
      return LeooDataResultJunPro(data, true);
    }
    return res;
  }

  static Future<LeooDataResultJunPro> LeooFindPageAuditUserExtJunPro(
      int page, LeooAuditEntity entity,
      [int? size]) async {
    Map<String, dynamic> other = {
      'page': page,
      'size': size ?? LeooAppConfigJunPro.leooListSizeJunPro,
    };
    other.addAll(entity.toJson());
    var res = await LeooMainDaoJunPro.leooFromBaseJsonJunPro(
        other, LeooAppHostJunPro.leooFindPageAuditUserExtJunPro(),
        room: true);
    if (res.result) {
      var data = (res.data['data'] as List)
          .map((v) => LeooAuditEntity.fromJson(v))
          .toList();
      return LeooDataResultJunPro(data, true);
    }
    return res;
  }

  static Future<LeooDataResultJunPro> LeooGetAuditTreeDataByIdJunPro(
      int? id) async {
    Map<String, dynamic> other = {'id': id};
    var res = await LeooMainDaoJunPro.leooFromBaseJsonJunPro(
        other, LeooAppHostJunPro.leooGetAuditTreeDataByIdJunPro(),
        room: true);
    if (res.result && res.data != null) {
      var entity = LeooAuditEntity.fromJson(res.data);
      return LeooDataResultJunPro(entity, true);
    }
    return res;
  }

  static Future<LeooDataResultJunPro> LeooGetAuditUserExtByUserIdJunPro(
      int? userId) async {
    Map<String, dynamic> other = {'userId': userId};
    var res = await LeooMainDaoJunPro.leooFromBaseJsonJunPro(
        other, LeooAppHostJunPro.leooGetAuditUserExtByUserIdJunPro(),
        room: true);
    if (res.result && res.data != null) {
      var entity = LeooAuditEntity.fromJson(res.data);
      return LeooDataResultJunPro(entity, true);
    }
    return res;
  }

  static Future<LeooDataResultJunPro> LeooGetCurUserAuditExtJunPro(
      LeooAuditEntity entity) async {
    var res = await LeooMainDaoJunPro.leooFromBaseJsonJunPro(
        null, LeooAppHostJunPro.leooGetCurUserAuditExtJunPro(),
        option: 'get');
    if (res.result && res.data != null) {
      var entity = LeooAuditEntity.fromJson(res.data);
      return LeooDataResultJunPro(entity, true);
    }
    return res;
  }
}
