import 'package:flutter/material.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:leoo_junpro/generated/l10n.dart';
import 'package:leoo_junpro/leooflagjunpro/leoostringjunpro/leoostylejunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocodeutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocommonutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoonavigatorutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leoocustomtabsjunpro.dart'
    as custom_tabs;
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leootabbarwidgetjunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leootopjunpro/leootopitemjunpro.dart';

///排行榜
class LeooTopJunPro extends StatefulWidget {
  const LeooTopJunPro({Key? key}) : super(key: key);

  @override
  _LeooTopState createState() => _LeooTopState();
}

class _LeooTopState extends State<LeooTopJunPro> {
  int curIndex = 0;

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      resizeToAvoidBottomInset: false,
      body: Stack(
        children: [
          topItemBg(),
          SafeArea(
            maintainBottomViewPadding: true,
            bottom: false,
            child: LeooTabBarWidgetJunPro(
              [
                custom_tabs.Tab(text: S.of(context).topCharm),
                custom_tabs.Tab(text: S.of(context).topRich),
                custom_tabs.Tab(text: S.of(context).topGifter),
              ],
              const [
                LeooTopItemJunPro(3),
                LeooTopItemJunPro(1),
                LeooTopItemJunPro(2),
              ],
              type: LeooTabBarWidgetJunPro.leooTaoTopJunPro,
              top: false,
              alignment: Alignment.bottomLeft,
              margin: EdgeInsets.only(left: 10.w, right: .3.sw, bottom: 10.w),
              padding: EdgeInsets.only(top: 5.w),
              isScrollable: true,
              indicatorColor: Colors.white,
              unselectedLabelColor: Colors.white.withOpacity(.8),
              onPageChanged: (index) {
                curIndex = index;
                LeooCodeUtilsJunPro.onSetState(this);
              },
            ),
          ),
          Positioned(
            top: ScreenUtil().statusBarHeight + 4.w,
            right: 4.w,
            child: IconButton(
              iconSize: 40.w,
              padding: const EdgeInsets.all(0),
              icon: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                  LeooIconsJunPro.leooPopClose2JunPro,
                  width: 40.w,
                  height: 40.w),
              onPressed: LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                Navigator.pop(context);
              }),
            ),
          ),
        ],
      ),
    );
  }

  Widget topItemBg() {
    return Container(
      width: 1.sw,
      height: 1.sw,
      decoration: BoxDecoration(
        gradient: LinearGradient(
          colors: curIndex == 0
              ? [
                  LeooColorsJunPro.leooTop1JunPro,
                  LeooColorsJunPro.leooTop1RightJunPro,
                ]
              : curIndex == 1
                  ? [
                      LeooColorsJunPro.leooTop2JunPro,
                      LeooColorsJunPro.leooTop2RightJunPro,
                    ]
                  : [
                      LeooColorsJunPro.leooTop3JunPro,
                      LeooColorsJunPro.leooTop3RightJunPro,
                    ],
        ),
      ),
    );
  }
}
